#!/usr/bin/env python
# -*- coding: utf-8 -*-

""" Simple TCP server   """

import sys
import socket
import random
from time import sleep

s = socket.socket()
s.setsockopt(socket.SOL_SOCKET, socket.SO_REUSEADDR, 1)
#s.connect(("localhost", 5000))
s.bind(("localhost", 5000))
print "Socket is listening"
s.listen(5)

while 1:
    #accept connections from outside
    try:
	(clientsocket, address) = s.accept()
	print "Socked accepted"
    except (KeyboardInterrupt, SystemExit):
	print "Exit on user request"
	s.close()
	sys.exit()
    
    while 1:
	buf = ''
	try:
	    buf = clientsocket.recv(256)
	except (KeyboardInterrupt, SystemExit):
	    print "Exit on user request"
	    clientsocket.close()
	    print "Socked closed"
	    break
	except socket.error:
	    clientsocket.close()
	    print "Socked closed"
	    break
	
	if ( len(buf) > 0 ):
	    print "RX ok"
	else:
	    print "RX failed"
	    break
	
	tt = random.random() * random.randint(0,1) * 10
	hh = random.randint(-999, 999)
	
	oline = "Temp: " + str(tt) + " ; Humidity: " + str(hh) + "\r\n"
	
	try:
	    ret = clientsocket.sendall(oline)
	except socket.error:
	    clientsocket.close()
	    print "Socked closed"
	    break
	
	if ret is None:
	    print "TX ok"
	    print oline ,
	
	sleep(0.1)


try:
    s.close()
except:
    pass


try:
    clientsocket.close()
except:
    pass


